var u, langpair, hl, ie, url, text, temp, temp2, tempindex, gtUrl="http://widgets.opera.com/widget/6580";
var version=2.4;
var heightText, heightURL, widthText, widthURL;
var txtHeightPadding=0, txtWidthPadding=0;

/*
 * fUpdate: Checks for updates and posts a notification in the widget for the user
 */
function fUpdate(){
	var requestUpdate = new XMLHttpRequest();
	requestUpdate.onreadystatechange = function() {
		var temp, tempindex;
		if(requestUpdate.readyState === 4) {
			if(requestUpdate.responseText === "") {
				return;
			}
			temp = requestUpdate.responseText;
			tempindex = temp.indexOf('<span class="left">V')+20;
			temp = temp.substr(tempindex);
			tempindex = temp.indexOf('</span>');
			temp = temp.substr(0,tempindex);
			//opera.postError(temp);
			if (temp > version) {
				if (widget.showNotification) {
					widget.showNotification("Update available: v"+temp, fUpdateNow);
				}
				document.getElementById('tabUpdateCon').innerHTML="Update!";
				$(document.getElementById('tabUpdate')).fadeIn("slow");
				//hide update after 5 minutes to stop annoying user
				setTimeout ('$(document.getElementById(\'tabUpdate\')).fadeOut("slow")', 300000);
			}
			//requestUpdate.close();
		}
	};
	requestUpdate.open("GET", gtUrl);
	requestUpdate.send();
}

/*
 * fUpdateNow: Opens the url to the download page for latest version
 */
function fUpdateNow() {
	widget.openURL(gtUrl);
}

/*
 * fTranslate: Checks the tab and translates text or opens url to be translated
 */
function fTranslate() {
	if (widget.preferenceForKey('translate')==="text") {
		document.getElementById('icoLoading').style.display="inline";
		document.getElementById('original').value=document.getElementById('input1').value;
		document.getElementById('languages').value=document.getElementById('sltTextFrom').value+"|"+document.getElementById('sltTextTo').value;
		url = "http://www.google.com/translate_t";
		//url = "http://www.google.com/translate_t?sl="+document.getElementById('sltTextFrom').value+"&tl="+document.getElementById('sltTextTo').value;
		hl = document.getElementById('hl').value;
		ie = document.getElementById('ie').value;
		langpair = document.getElementById('languages').value;
		text = encodeURIComponent(document.getElementById('original').value);
		var xmlhttp=new XMLHttpRequest();
		xmlhttp.open("POST",url,false);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp.onreadystatechange=function() {
			var queryresults=document.createElement('div');
			if(xmlhttp.readyState===4) {
				queryresults.innerHTML=xmlhttp.responseText;
				temp=queryresults.innerHTML;
				//opera.postError("Google Translator [fTranslate()]:\nStored xmlrequest in div triggers ~10 CSS errors/warnings in Error Console.");
				if (temp.indexOf('id="result_box"')<0) {
					document.getElementById('input2').value="";
					if (widget.showNotification) {
						widget.showNotification("Sorry. Google is unable to determine the language.");
					}
				} else {
					temp = temp.substr(temp.lastIndexOf("Translation:</SPAN>")+20);
					temp2= temp;
					if (document.getElementById('sltTextFrom').value==="auto" && temp.indexOf('(automatically detected)')>-1) {
						fUpdateAutoDetectLang(temp.substr(0,temp.indexOf("(automatically detected)")-1));
					}
					temp = temp.substr(temp.indexOf('id="result_box"')+15);
					temp = temp.substr(temp.indexOf('>')+1);
					temp = temp.substr(0,temp.indexOf('</DIV>'));
					
					if (temp2.indexOf('id="dict"')>0) {
						temp2 = temp2.substr(temp2.indexOf('id="dict"')+9);
						temp2 = temp2.substr(temp2.indexOf('<TBODY>')+7);
						temp2 = temp2.substr(0,temp2.indexOf('</TBODY>'));
						temp2 = temp2.substr(0,temp2.indexOf('</TD></TR><TR><TD><A '));
						//opera.postError(temp2);
						
						temp2 = temp2.replace(/<tr>/gi, "");
						temp2 = temp2.replace(/<\/tr>/gi, "\n");
						temp2 = temp2.replace(/<td valign="top">/gi, "-");
						temp2 = temp2.replace(/<td>/gi, "");
						temp2 = temp2.replace(/<\/td>/gi, "\n");
						temp2 = temp2.replace(/<ol>/gi, "");
						temp2 = temp2.replace(/<\/ol>/gi, "");
						temp2 = temp2.replace(/<li>/gi, "  ");
						temp2 = temp2.replace(/<\/li>/gi, "\n");
						//opera.postError(temp2);
						
						if (temp2 != "")
							temp  = temp+"\n\nDictionary:\n"+temp2;
					}
					
					temp = temp.replace(/\<br\>\ /gi, "\n");
					temp = temp.replace(/<span [^>]*>/gi, "");
					temp = temp.replace(/<\/span>/gi, "");
					
					if (temp.length>0) {
						document.getElementById('input2').value=temp;
					} else if (document.getElementById('sltTextFrom').value==="auto") {
						document.getElementById('input2').value="";
						if (widget.showNotification) {
							widget.showNotification("Sorry. Google is unable to determine the language.");
						}
					} else {
						document.getElementById('input2').value="";
						if (widget.showNotification) {
							widget.showNotification("Sorry. Google encountered an unexpected error.");
						}
					}
				}
				//document.getElementById('icoLoading').style.visibility="hidden";
				$(document.getElementById('icoLoading')).fadeOut("slow");
			}
		};
		xmlhttp.send('hl=en&ie=UTF8&text='+text+'&langpair='+langpair+'&hl=en&ie=UTF8');
	} else if (widget.preferenceForKey('translate')==="url") {
		u = encodeURIComponent(document.getElementById('u').value);
		langpair = document.getElementById('sltURLFrom').value+"|"+document.getElementById('sltURLTo').value;
		langpair = encodeURIComponent(langpair);
		hl = document.getElementById('hl').value;
		ie = document.getElementById('ie').value;
		url = "http://translate.google.com/translate?u="+u+"&langpair="+langpair+"&hl="+hl+"&ie="+"UTF-8"+"&oe="+"UTF-8";
		widget.openURL(url);
	}
}

/*
 * fReverseLanguages: Checks the tab and reverses the selected language pair
 */
function fReverseLanguages() {
	if (widget.preferenceForKey('translate')==="text" && document.getElementById('sltTextFrom').value!=="auto") {
		var lang=document.getElementById('sltTextFrom').value;
		document.getElementById('sltTextFrom').value=document.getElementById('sltTextTo').value;
		document.getElementById('sltTextTo').value=lang;
		document.getElementById('mnuReverse').style.display="none";
		fSaveTextFromTo();
	} else if (widget.preferenceForKey('translate')==="url" && document.getElementById('sltURLFrom').value!=="auto") {
		var lang=document.getElementById('sltURLFrom').value;
		document.getElementById('sltURLFrom').value=document.getElementById('sltURLTo').value;
		document.getElementById('sltURLTo').value=lang;
		fSaveURLFromTo();
	}
}

/*
 * fClearText: Accepts an input id and clears the input text (or resets it)
 */
function fClearText(textbox) {
	if (textbox===1) {
		document.getElementById('input1').value="";
	} else if (textbox===2) {
		document.getElementById('input2').value="";
	} else if (textbox===3) {
		document.getElementById('u').value="http://";
	}
}

/*
 * fFlipText: Flips text between inputs in text translation mode
 */
function fFlipText() {
	var original=document.getElementById('input1').value;
	document.getElementById('input1').value=document.getElementById('input2').value;
	document.getElementById('input2').value=original;
	document.getElementById('mnuReverse').style.display="none";
}

/*
 * fOptions: Sets images for events on options button and shows/hides options in footer
 */
function fOptions(option) {
	if (document.getElementById('conOptions').style.display==="none") {
		if (option==1) {
			document.getElementById('icoOptions').src="imgs/options1.png";
		} else if (option==2) {
			document.getElementById('icoOptions').src="imgs/options2.png";
		} else if (option==3) {
			document.getElementById('icoOptions').src="imgs/options3.png";
		} else if (option==4) {
			$(document.getElementById('conOptions')).fadeIn("slow");
			document.getElementById('icoOptions').src="imgs/options5.png";
			widget.setPreferenceForKey('1','options');
		}
	} else {
		if (option==1) {
			document.getElementById('icoOptions').src="imgs/options4.png";
		} else if (option==2) {
			document.getElementById('icoOptions').src="imgs/options5.png";
		} else if (option==3) {
			document.getElementById('icoOptions').src="imgs/options6.png";
		} else if (option==4) {
			$(document.getElementById('conOptions')).fadeOut("slow");
			document.getElementById('icoOptions').src="imgs/options2.png";
			widget.setPreferenceForKey('0','options');
		}
	}
}

/*
 * fText: Shows the text translation mode when the Text tab is selected
 */
function fText() {
	document.getElementById('conURL').style.display="none";
	document.getElementById('conBody').style.height=heightText+"px";
	
	var bodyHeight=document.getElementById('conBody').style.height;
	bodyHeight=bodyHeight.replace("px","");
	var footerTop=(bodyHeight*1)+2;
	document.getElementById('conFooter').style.top=footerTop+"px";
	
	document.getElementById('mnuReverse').style.top=(footerTop-8)+"px";
	document.getElementById('mnuMore').style.top=(footerTop-72)+"px";
	
	$(document.getElementById('conText')).fadeIn("slow");
	
	document.getElementById('tabTextbg').src="imgs/tab-1.png";
	document.getElementById('tabURLbg').src="imgs/tab-2.png";
	document.getElementById('tabText').style.zIndex=2;
	document.getElementById('tabURL').style.zIndex=1;
	
	document.getElementById('cmbMore').style.display="inline";
	
	document.getElementById('tabURL').style.fontWeight='';
	document.getElementById('tabText').style.fontWeight="bold";
	document.getElementById('input1').focus()
	
	widget.setPreferenceForKey('text','translate');
	//window.resizeTo(269,211);
}

/*
 * fURL: Shows the url translation mode when the URL tab is selected
 */
function fURL() {
	document.getElementById('conText').style.display="none";
	document.getElementById('conBody').style.height=heightURL+"px";
	
	var bodyHeight=document.getElementById('conBody').style.height;
	bodyHeight=bodyHeight.replace("px","");
	var footerTop=(bodyHeight*1)+2;
	document.getElementById('conFooter').style.top=footerTop+"px";
	
	$(document.getElementById('conURL')).fadeIn("slow");
	
	document.getElementById('tabURLbg').src="imgs/tab-1.png";
	document.getElementById('tabTextbg').src="imgs/tab-2.png";
	document.getElementById('tabURL').style.zIndex=2;
	document.getElementById('tabText').style.zIndex=1;

	document.getElementById('cmbMore').style.display="none";

	document.getElementById('tabText').style.fontWeight='';
	document.getElementById('tabURL').style.fontWeight="bold";
	//document.getElementById('u').focus() //disabled: saved urls in Opera prefs continually nag the user
	
	widget.setPreferenceForKey('url','translate');
	//window.resizeTo(269,211);
}

/*
 * fMinMax: Minimizes the widget or restores it
 */
function fMinMax() {
	if (document.getElementById('conBodyFooter').style.display==="none") {
		$(document.getElementById('conBodyFooter')).slideDown("slow");
		//timer delay to make visually more pleasing
		setTimeout ('document.getElementById(\'conTabs\').style.display="inline"', 500);
		document.getElementById('icoMinmax').src="imgs/min.png";
		widget.setPreferenceForKey('0','minimized');
	} else {
		document.getElementById('conTabs').style.display="none";
		$(document.getElementById('conBodyFooter')).slideUp("slow");
		document.getElementById('icoMinmax').src="imgs/max.png";
		widget.setPreferenceForKey('1','minimized');
	}
}

/*
 * fSaveTextFromTo: Saves select boxes for Text translation From and to
 */
function fSaveTextFromTo() {
	widget.setPreferenceForKey(document.getElementById('sltTextFrom').value,'sltTextFrom');
	widget.setPreferenceForKey(document.getElementById('sltTextTo').value,'sltTextTo');
}

/*
 * fSaveURLFromTo: Saves select boxes for URL translation From and to
 */
function fSaveURLFromTo() {
	widget.setPreferenceForKey(document.getElementById('sltURLFrom').value,'sltURLFrom');
	widget.setPreferenceForKey(document.getElementById('sltURLTo').value,'sltURLTo');
}

/*
 * fUpdateAutoDetectLang: The language that Google auto-detects is set on text mode
 */
function fUpdateAutoDetectLang(lang) {
	if (lang==="Afrikaans") {
		document.getElementById('sltTextFrom').value="af";
	} else if (lang==="Albanian") {
		document.getElementById('sltTextFrom').value="sq";
	} else if (lang==="Arabic") {
		document.getElementById('sltTextFrom').value="ar";
	} else if (lang==="Bulgarian") {
		document.getElementById('sltTextFrom').value="bg";
	} else if (lang==="Catalan") {
		document.getElementById('sltTextFrom').value="ca";
	} else if (lang==="Chinese") {
		document.getElementById('sltTextFrom').value="zh-CN";
	} else if (lang==="Croatian") {
		document.getElementById('sltTextFrom').value="hr";
	} else if (lang==="Czech") {
		document.getElementById('sltTextFrom').value="cs";
	} else if (lang==="Danish") {
		document.getElementById('sltTextFrom').value="da";
	} else if (lang==="Dutch") {
		document.getElementById('sltTextFrom').value="nl";
	} else if (lang==="English") {
		document.getElementById('sltTextFrom').value="en";
	} else if (lang==="Estonian") {
		document.getElementById('sltTextFrom').value="et";
	} else if (lang==="Filipino") {
		document.getElementById('sltTextFrom').value="tl";
	} else if (lang==="Finnish") {
		document.getElementById('sltTextFrom').value="fi";
	} else if (lang==="French") {
		document.getElementById('sltTextFrom').value="fr";
	} else if (lang==="Galician") {
		document.getElementById('sltTextFrom').value="gl";
	} else if (lang==="German") {
		document.getElementById('sltTextFrom').value="de";
	} else if (lang==="Greek") {
		document.getElementById('sltTextFrom').value="el";
	} else if (lang==="Hebrew") {
		document.getElementById('sltTextFrom').value="iw";
	} else if (lang==="Hindi") {
		document.getElementById('sltTextFrom').value="hi";
	} else if (lang==="Hungarian") {
		document.getElementById('sltTextFrom').value="hu";
	} else if (lang==="Icelandic") {
		document.getElementById('sltTextFrom').value="is";
	} else if (lang==="Indonesian") {
		document.getElementById('sltTextFrom').value="id";
	} else if (lang==="Irish") {
		document.getElementById('sltTextFrom').value="ga";
	} else if (lang==="Italian") {
		document.getElementById('sltTextFrom').value="it";
	} else if (lang==="Japanese") {
		document.getElementById('sltTextFrom').value="ja";
	} else if (lang==="Korean") {
		document.getElementById('sltTextFrom').value="ko";
	} else if (lang==="Latvian") {
		document.getElementById('sltTextFrom').value="lv";
	} else if (lang==="Lithuanian") {
		document.getElementById('sltTextFrom').value="lt";
	} else if (lang==="Macedonian") {
		document.getElementById('sltTextFrom').value="mk";
	} else if (lang==="Malay") {
		document.getElementById('sltTextFrom').value="ms";
	} else if (lang==="Maltese") {
		document.getElementById('sltTextFrom').value="mt";
	} else if (lang==="Norwegian") {
		document.getElementById('sltTextFrom').value="no";
	} else if (lang==="Persian") {
		document.getElementById('sltTextFrom').value="fa";
	} else if (lang==="Polish") {
		document.getElementById('sltTextFrom').value="pl";
	} else if (lang==="Portuguese") {
		document.getElementById('sltTextFrom').value="pt";
	} else if (lang==="Romanian") {
		document.getElementById('sltTextFrom').value="ro";
	} else if (lang==="Russian") {
		document.getElementById('sltTextFrom').value="ru";
	} else if (lang==="Serbian") {
		document.getElementById('sltTextFrom').value="sr";
	} else if (lang==="Slovak") {
		document.getElementById('sltTextFrom').value="sk";
	} else if (lang==="Slovenian") {
		document.getElementById('sltTextFrom').value="sl";
	} else if (lang==="Spanish") {
		document.getElementById('sltTextFrom').value="es";
	} else if (lang==="Swahili") {
		document.getElementById('sltTextFrom').value="sw";
	} else if (lang==="Swedish") {
		document.getElementById('sltTextFrom').value="sv";
	} else if (lang==="Thai") {
		document.getElementById('sltTextFrom').value="th";
	} else if (lang==="Turkish") {
		document.getElementById('sltTextFrom').value="tr";
	} else if (lang==="Ukrainian") {
		document.getElementById('sltTextFrom').value="uk";
	} else if (lang==="Vietnamese") {
		document.getElementById('sltTextFrom').value="vi";
	} else if (lang==="Welsh") {
		document.getElementById('sltTextFrom').value="cy";
	} else if (lang==="Yiddish") {
		document.getElementById('sltTextFrom').value="yi";
	}
	fSaveTextFromTo();
}

/*
 * fClear: Action performed by the "Clear" button that clears input fields
 */
function fClear() {
	if (widget.preferenceForKey('translate')==="text") {
		fClearText(1);
		fClearText(2);
	} else if (widget.preferenceForKey('translate')==="url") {
		fClearText(3);
	}
}

/*
 * fReverse: Checks the tab and displays the "Reverse" menu or reverses the languages on the url tab
 */
function fReverse() {
	if (widget.preferenceForKey('translate')==="text") {
		document.getElementById('mnuReverse').style.display="inline";
	} else if (widget.preferenceForKey('translate')==="url") {
		fReverseLanguages();
	}
}

/*
 * fMore: Displays the "More" menu
 */
function fMore() {
	document.getElementById('mnuMore').style.display='inline';
}

/*
 * fClearMenus: Clears the menus to get them out of the way when needed
 */
function fClearMenus() {
	document.getElementById('mnuReverse').style.display='none';
	document.getElementById('mnuMore').style.display='none';
}

/*
 * Created by: Mark O'Sullivan :: http://lussumo.com/
 * Jeff Larson :: http://www.jeffothy.com/
 * Mark Percival :: http://webchicanery.com/
 * copy: Sends text from specified input to a flash element that copies the text to the clipboard
 */
function copy(text2copy) {
    document.getElementById('flashcopier').innerHTML = '';
    var divinfo = '<embed src="_clipboard.swf" FlashVars="clipboard='+escape(text2copy)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';
    document.getElementById('flashcopier').innerHTML = divinfo;
}

/*
 * loadSaved: Sets saved settings from preferences to adjust widget
 */
function loadSaved() {
	// Start: Check for version of Opera to make any changes needed between versions to make this widget work the same in all versions
	if (/Opera[\/\s](\d+\.\d+)/.test(navigator.userAgent)){ //test for Opera/x.x or Opera x.x (ignoring remaining decimal places);
		var oprversion=new Number(RegExp.$1) // capture x.x portion and store as a number
		if (oprversion<9.5) {
			txtHeightPadding=4;
			txtWidthPadding=4;
			
			//temp resize fix until widget resizing is completed
			document.getElementById('input1').style.height="52px";
			document.getElementById('input1').style.width="261px";
			document.getElementById('input2').style.height="52px";
			document.getElementById('input2').style.width="261px";
		}
	}
	// End: Check for version of Opera to make any changes needed between versions to make this widget work the same in all versions
	
	// Set current version number in Widget
	document.getElementById('conVersion').innerHTML=version;
	
	// Start: Set widget sizes
	if (widget.preferenceForKey('heightText')==="") {
		widget.setPreferenceForKey('134','heightText');
	}
	if (widget.preferenceForKey('heightURL')==="") {
		widget.setPreferenceForKey('47','heightURL');
	}
	if (widget.preferenceForKey('widthText')==="") {
		widget.setPreferenceForKey('265','widthText');
	}
	if (widget.preferenceForKey('widthURL')==="") {
		widget.setPreferenceForKey('265','widthURL');
	}
	heightText=widget.preferenceForKey('heightText');
	heightURL=widget.preferenceForKey('heightURL');
	widthText=widget.preferenceForKey('widthText');
	widthURL=widget.preferenceForKey('widthURL');
	// End: Set widget sizes
	
	// Start: Set saved tab
	if (widget.preferenceForKey('translate')==="url") {
		fURL();
	} else if (widget.preferenceForKey('translate')==="text") {
		fText();
	} else {
		widget.setPreferenceForKey('text','translate');
	}
	// End: Set saved tab
	
	// Start: Check to see if widget was minimized when closed
	if (widget.preferenceForKey('minimized')==="1") {
		fMinMax();
	}
	// End: Check to see if widget was minimized when closed
	
	// Start: Check to see if option tools were last visible, if not hide them
	if (widget.preferenceForKey('options')==="0") {
		fOptions(4);
	}
	// End: Check to see if option tools were last visible, if not hide them

	// Start: Set saved language translation pair for Text and URL
	if (widget.preferenceForKey('sltTextFrom')==="") {
		widget.setPreferenceForKey('es','sltTextFrom');
	}
	if (widget.preferenceForKey('sltTextTo')==="") {
		widget.setPreferenceForKey('en','sltTextTo');
	}
	document.getElementById('sltTextFrom').value=widget.preferenceForKey('sltTextFrom');
	document.getElementById('sltTextTo').value=widget.preferenceForKey('sltTextTo');
	if (widget.preferenceForKey('sltURLFrom')==="") {
		widget.setPreferenceForKey('es','sltURLFrom');
	}
	if (widget.preferenceForKey('sltURLTo')==="") {
		widget.setPreferenceForKey('en','sltURLTo');
	}
	document.getElementById('sltURLFrom').value=widget.preferenceForKey('sltURLFrom');
	document.getElementById('sltURLTo').value=widget.preferenceForKey('sltURLTo');
	// End: Set saved language translation pair for Text and URL
	
	// Check for updates
	fUpdate();
}
